<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/resources/XMLDocument.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_b1edfc2c49307e65a973a203b2244023.html">resources</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">XMLDocument.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="XMLDocument_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &quot;../../libs/tinyxml2/tinyxml2.h&quot;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &quot;<a class="code" href="Attributes_8hpp.html">Attributes.hpp</a>&quot;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span> </div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span>{</div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span> </div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html">    9</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>{</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a876cb3c42d4dfd9b28634ce54fefdb17">   12</a></span>    <a class="code hl_function" href="classgg_1_1XMLDocument.html#a876cb3c42d4dfd9b28634ce54fefdb17">XMLDocument</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a02ab9b46a49f31b8d7405435136d7257">   13</a></span>    <a class="code hl_function" href="classgg_1_1XMLDocument.html#a02ab9b46a49f31b8d7405435136d7257">XMLDocument</a>(std::string name, <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> attributes, std::string content);</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a47ac0d9ae4d87ee9a7d2c2271991e9e1">   14</a></span>    <a class="code hl_function" href="classgg_1_1XMLDocument.html#a47ac0d9ae4d87ee9a7d2c2271991e9e1">XMLDocument</a>(</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>        std::string name,</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>        <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> attributes,</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>        std::string content,</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>        std::vector&lt;XMLDocument&gt; children);</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#ae8db8c5250eb6ebe7c0bdb953729940c">   19</a></span>    <span class="keyword">virtual</span> <a class="code hl_function" href="classgg_1_1XMLDocument.html#ae8db8c5250eb6ebe7c0bdb953729940c">~XMLDocument</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#ad3f14c02d9c64abed8fc7b41f399afe6">   21</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1XMLDocument.html#ad3f14c02d9c64abed8fc7b41f399afe6">AddChild</a>(<a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a>);</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a859620ce17eed3d46de08b08e540a66e">   22</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1XMLDocument.html#a859620ce17eed3d46de08b08e540a66e">RemoveChild</a>(<span class="keywordtype">int</span> i);</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a7acdd509f5c9417138d9a5bfc161fc5a">   24</a></span>    [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1XMLDocument.html#a7acdd509f5c9417138d9a5bfc161fc5a">GetName</a>() const -&gt; const <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> &amp;;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a3fa4567a3c353ecf82c798ea6a3746c1">   25</a></span>    [[nodiscard]] auto <a class="code hl_function" href="classgg_1_1XMLDocument.html#a3fa4567a3c353ecf82c798ea6a3746c1">GetAttributes</a>() const -&gt; const <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> &amp;;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a1a399757e1e371f07154c606bed1199e">   26</a></span>    [[nodiscard]] auto <a class="code hl_function" href="classgg_1_1XMLDocument.html#a1a399757e1e371f07154c606bed1199e">GetContent</a>() const -&gt; const <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> &amp;;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#ab3307ad181f7c3fe01039755b6c90443">   27</a></span>    [[nodiscard]] auto <a class="code hl_function" href="classgg_1_1XMLDocument.html#ab3307ad181f7c3fe01039755b6c90443">GetChildren</a>() const -&gt; const <a class="code hl_namespace" href="namespacestd.html">std</a>::vector&lt;<a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a>&gt; &amp;;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a406b523274a43def875834ca9e1893c1">   29</a></span>    auto <a class="code hl_function" href="classgg_1_1XMLDocument.html#ab3307ad181f7c3fe01039755b6c90443">GetChildren</a>() -&gt; <a class="code hl_namespace" href="namespacestd.html">std</a>::vector&lt;<a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a>&gt; &amp;;</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#ac141b684643d2826c25b704c197eb7a4">   30</a></span>    static auto <a class="code hl_function" href="classgg_1_1XMLDocument.html#ac141b684643d2826c25b704c197eb7a4">LoadFromFile</a>(const <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> &amp;) -&gt; <a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a>;</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="classgg_1_1XMLDocument.html#a2874c3134eb2b862532876a06d1fdb4a">   31</a></span>    static <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1XMLDocument.html#a2874c3134eb2b862532876a06d1fdb4a">SaveToFile</a>(const <a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a> &amp;, const <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> &amp;);</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>  private:</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    static auto LoadFromElement(tinyxml2::XMLElement *) -&gt; <a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a>;</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    static auto LoadAttributesFromElement(tinyxml2::XMLElement *) -&gt; <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a>;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    static auto</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    CreateElement(tinyxml2::<a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a> &amp;, const <a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a> &amp;) -&gt; tinyxml2::XMLElement *;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>  private:</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>    <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> mName;</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>    <a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a> mAttributes;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span> mContent;</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>    <a class="code hl_namespace" href="namespacestd.html">std</a>::vector&lt;<a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a>&gt; mChildren;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>};</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span> </div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aAttributes_8hpp_html"><div class="ttname"><a href="Attributes_8hpp.html">Attributes.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html"><div class="ttname"><a href="classgg_1_1Attributes.html">gg::Attributes</a></div><div class="ttdef"><b>Definition:</b> Attributes.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html"><div class="ttname"><a href="classgg_1_1XMLDocument.html">gg::XMLDocument</a></div><div class="ttdef"><b>Definition:</b> XMLDocument.hpp:10</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a02ab9b46a49f31b8d7405435136d7257"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a02ab9b46a49f31b8d7405435136d7257">gg::XMLDocument::XMLDocument</a></div><div class="ttdeci">XMLDocument(std::string name, Attributes attributes, std::string content)</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a1a399757e1e371f07154c606bed1199e"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a1a399757e1e371f07154c606bed1199e">gg::XMLDocument::GetContent</a></div><div class="ttdeci">auto GetContent() const -&gt; const std::string &amp;</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a2874c3134eb2b862532876a06d1fdb4a"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a2874c3134eb2b862532876a06d1fdb4a">gg::XMLDocument::SaveToFile</a></div><div class="ttdeci">static void SaveToFile(const XMLDocument &amp;, const std::string &amp;)</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a3fa4567a3c353ecf82c798ea6a3746c1"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a3fa4567a3c353ecf82c798ea6a3746c1">gg::XMLDocument::GetAttributes</a></div><div class="ttdeci">auto GetAttributes() const -&gt; const Attributes &amp;</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a47ac0d9ae4d87ee9a7d2c2271991e9e1"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a47ac0d9ae4d87ee9a7d2c2271991e9e1">gg::XMLDocument::XMLDocument</a></div><div class="ttdeci">XMLDocument(std::string name, Attributes attributes, std::string content, std::vector&lt; XMLDocument &gt; children)</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a7acdd509f5c9417138d9a5bfc161fc5a"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a7acdd509f5c9417138d9a5bfc161fc5a">gg::XMLDocument::GetName</a></div><div class="ttdeci">auto GetName() const -&gt; const std::string &amp;</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a859620ce17eed3d46de08b08e540a66e"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a859620ce17eed3d46de08b08e540a66e">gg::XMLDocument::RemoveChild</a></div><div class="ttdeci">void RemoveChild(int i)</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_a876cb3c42d4dfd9b28634ce54fefdb17"><div class="ttname"><a href="classgg_1_1XMLDocument.html#a876cb3c42d4dfd9b28634ce54fefdb17">gg::XMLDocument::XMLDocument</a></div><div class="ttdeci">XMLDocument()=default</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_ab3307ad181f7c3fe01039755b6c90443"><div class="ttname"><a href="classgg_1_1XMLDocument.html#ab3307ad181f7c3fe01039755b6c90443">gg::XMLDocument::GetChildren</a></div><div class="ttdeci">auto GetChildren() const -&gt; const std::vector&lt; XMLDocument &gt; &amp;</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_ac141b684643d2826c25b704c197eb7a4"><div class="ttname"><a href="classgg_1_1XMLDocument.html#ac141b684643d2826c25b704c197eb7a4">gg::XMLDocument::LoadFromFile</a></div><div class="ttdeci">static auto LoadFromFile(const std::string &amp;) -&gt; XMLDocument</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_ad3f14c02d9c64abed8fc7b41f399afe6"><div class="ttname"><a href="classgg_1_1XMLDocument.html#ad3f14c02d9c64abed8fc7b41f399afe6">gg::XMLDocument::AddChild</a></div><div class="ttdeci">void AddChild(XMLDocument)</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html_ae8db8c5250eb6ebe7c0bdb953729940c"><div class="ttname"><a href="classgg_1_1XMLDocument.html#ae8db8c5250eb6ebe7c0bdb953729940c">gg::XMLDocument::~XMLDocument</a></div><div class="ttdeci">virtual ~XMLDocument()=default</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:84</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
